/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1



/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 12 "src/parser/parser.ypp"

#include <cstdlib>
#include <iostream>

#include "parser/ast.hpp"
#include "proofs/dichotomy.hpp"
#include "parser/parser.hpp"

#define yyerror(msg) my_yyerror(yylloc, msg)

int yylex(YYSTYPE *yylval_param, YYLTYPE *yylloc_param);

#define error(msg) \
  std::cerr << "Error: " << msg << " at line " << yylloc.first_line << " column " << yylloc.first_column << '\n'
#define warning(msg) \
  std::cerr << "Warning: " << msg << " at line " << yylloc.first_line << " column " << yylloc.first_column << '\n'

int my_yyerror(YYLTYPE &yylloc, char const *errstr) {
    error(errstr);
    return EXIT_FAILURE;
}

#define failure(msg) do {\
  error(msg); \
  YYERROR; \
} while (0)

extern void register_user_rewrite(ast_real const *, ast_real const *, hint_cond_vect *);
extern void generate_graph(ast_prop const *p);
extern void parse_property_tree(property_tree &tree, ast_prop const *p);
extern void test_ringularity(ast_real const *, ast_real const *, bool);
extern int test_rewriting(ast_real const *, ast_real const *, std::string &);
extern void check_approx(ast_real const *);
extern std::set< ast_real const * > free_variables;
extern bool parameter_rfma;

static ast_number const *negative_number(ast_number const *nn) {
  if (nn->base == 0) return nn;
  ast_number n = *nn;
  char &c = n.mantissa[0];
  assert(c == '+');
  c = '-';
  return normalize(n);
}

static function_class const *rounding_mode = NULL;

static ast_real const *rnd_normalize(ast_real const &real) {
  ast_real const *r = normalize(real);
  if (!rounding_mode) return r;
  return normalize(ast_real(real_op(rounding_mode, r)));
}

static unsigned long read_integer_param(ast_number const *n)
{
  return (unsigned long)(atoi(n->mantissa.c_str()) * 2) | 1;
}

#define YYINCLUDED_STDLIB_H



/* Line 268 of yacc.c  */
#line 134 "src/parser/parser.cpp"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENT = 258,
     FUNID = 259,
     VARID = 260,
     IN = 261,
     NUMBER = 262,
     SQRT = 263,
     FMA = 264,
     NE = 265,
     LE = 266,
     GE = 267,
     RDIV = 268,
     FIX = 269,
     FLT = 270,
     IMPL = 271,
     OR = 272,
     AND = 273,
     NOT = 274,
     NEG = 275
   };
#endif
/* Tokens.  */
#define IDENT 258
#define FUNID 259
#define VARID 260
#define IN 261
#define NUMBER 262
#define SQRT 263
#define FMA 264
#define NE 265
#define LE 266
#define GE 267
#define RDIV 268
#define FIX 269
#define FLT 270
#define IMPL 271
#define OR 272
#define AND 273
#define NOT 274
#define NEG 275




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 80 "src/parser/parser.ypp"

  ast_number const	*number;
  ast_ident		*ident;
  ast_real const	*real;
  ast_real_vect		*reals;
  dichotomy_var		dvar;
  dvar_vect		*dvars;
  ast_prop		*prop;
  function_class const	*function;
  function_params	*params;
  unsigned long		param;
  hint_cond		*precond;
  hint_cond_vect	*preconds;



/* Line 293 of yacc.c  */
#line 227 "src/parser/parser.cpp"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 252 "src/parser/parser.cpp"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  4
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   351

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  41
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  22
/* YYNRULES -- Number of rules.  */
#define YYNRULES  78
/* YYNRULES -- Number of states.  */
#define YYNSTATES  188

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   275

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,    39,     2,     2,     2,
      27,    29,    22,    20,    28,    21,     2,    23,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    37,
      35,    34,    36,    32,    38,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    30,     2,    31,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    25,    33,    26,    40,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    24
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,    11,    15,    22,    29,    37,    41,
      45,    55,    63,    69,    73,    77,    81,    85,    89,    92,
      96,    98,   101,   104,   106,   108,   110,   112,   114,   118,
     119,   123,   126,   128,   131,   132,   138,   145,   148,   151,
     155,   159,   161,   163,   165,   170,   174,   178,   182,   186,
     190,   195,   204,   208,   211,   214,   216,   220,   222,   226,
     228,   232,   238,   240,   244,   248,   252,   256,   260,   264,
     266,   270,   271,   275,   276,   283,   289,   295,   300
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      42,     0,    -1,    43,    62,    -1,    53,    25,    44,    26,
      -1,    54,    11,    45,    -1,    14,    27,    54,    28,    47,
      29,    -1,    15,    27,    54,    28,    46,    29,    -1,    54,
       6,    30,    45,    28,    45,    31,    -1,    54,     6,    32,
      -1,    54,    12,    45,    -1,    54,    13,    54,     6,    30,
      45,    28,    45,    31,    -1,    33,    54,    13,    54,    33,
      11,     7,    -1,    54,    13,    54,     6,    32,    -1,    54,
      34,    54,    -1,    54,    10,    54,    -1,    44,    18,    44,
      -1,    44,    17,    44,    -1,    44,    16,    44,    -1,    19,
      44,    -1,    27,    44,    29,    -1,     7,    -1,    20,     7,
      -1,    21,     7,    -1,     7,    -1,    45,    -1,    47,    -1,
       3,    -1,    48,    -1,    49,    28,    48,    -1,    -1,    35,
      49,    36,    -1,     4,    50,    -1,    34,    -1,    51,    34,
      -1,    -1,    53,     3,    52,    54,    37,    -1,    53,    38,
       3,    34,    51,    37,    -1,    53,     5,    -1,    53,     4,
      -1,    53,    38,     5,    -1,    53,    38,     4,    -1,    45,
      -1,     5,    -1,     3,    -1,    51,    27,    55,    29,    -1,
      54,    20,    54,    -1,    54,    21,    54,    -1,    54,    22,
      54,    -1,    54,    23,    54,    -1,    33,    54,    33,    -1,
       8,    27,    54,    29,    -1,     9,    27,    54,    28,    54,
      28,    54,    29,    -1,    27,    54,    29,    -1,    20,    54,
      -1,    21,    54,    -1,    54,    -1,    55,    28,    54,    -1,
      45,    -1,    56,    28,    45,    -1,    54,    -1,    54,     6,
      46,    -1,    54,     6,    27,    56,    29,    -1,    57,    -1,
      58,    28,    57,    -1,    54,    10,    47,    -1,    54,    11,
      47,    -1,    54,    12,    47,    -1,    54,    35,    47,    -1,
      54,    36,    47,    -1,    59,    -1,    60,    28,    59,    -1,
      -1,    25,    60,    26,    -1,    -1,    62,    54,    16,    54,
      61,    37,    -1,    62,    55,    39,    58,    37,    -1,    62,
      44,    39,    58,    37,    -1,    62,    39,    58,    37,    -1,
      62,    54,    40,    54,    37,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   126,   126,   127,   130,   135,   137,   139,   141,   142,
     143,   145,   147,   148,   149,   155,   156,   157,   158,   159,
     162,   163,   164,   167,   174,   181,   182,   185,   186,   194,
     195,   198,   211,   212,   219,   220,   231,   237,   238,   239,
     240,   243,   244,   245,   254,   265,   266,   267,   268,   269,
     270,   271,   278,   279,   280,   283,   284,   291,   292,   295,
     296,   297,   300,   301,   308,   309,   310,   311,   312,   315,
     316,   323,   324,   326,   327,   347,   363,   370,   376
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "FUNID", "VARID", "IN",
  "NUMBER", "SQRT", "FMA", "NE", "LE", "GE", "RDIV", "FIX", "FLT", "IMPL",
  "OR", "AND", "NOT", "'+'", "'-'", "'*'", "'/'", "NEG", "'{'", "'}'",
  "'('", "','", "')'", "'['", "']'", "'?'", "'|'", "'='", "'<'", "'>'",
  "';'", "'@'", "'$'", "'~'", "$accept", "BLOB", "BLOB1", "PROP",
  "SNUMBER", "INTEGER", "SINTEGER", "FUNCTION_PARAM",
  "FUNCTION_PARAMS_AUX", "FUNCTION_PARAMS", "FUNCTION", "EQUAL", "PROG",
  "REAL", "REALS", "DPOINTS", "DVAR", "DVARS", "PRECOND", "PRECONDS_AUX",
  "PRECONDS", "HINTS", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      43,    45,    42,    47,   275,   123,   125,    40,    44,    41,
      91,    93,    63,   124,    61,    60,    62,    59,    64,    36,
     126
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    41,    42,    43,    44,    44,    44,    44,    44,    44,
      44,    44,    44,    44,    44,    44,    44,    44,    44,    44,
      45,    45,    45,    46,    47,    48,    48,    49,    49,    50,
      50,    51,    52,    52,    53,    53,    53,    53,    53,    53,
      53,    54,    54,    54,    54,    54,    54,    54,    54,    54,
      54,    54,    54,    54,    54,    55,    55,    56,    56,    57,
      57,    57,    58,    58,    59,    59,    59,    59,    59,    60,
      60,    61,    61,    62,    62,    62,    62,    62,    62
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     4,     3,     6,     6,     7,     3,     3,
       9,     7,     5,     3,     3,     3,     3,     3,     2,     3,
       1,     2,     2,     1,     1,     1,     1,     1,     3,     0,
       3,     2,     1,     2,     0,     5,     6,     2,     2,     3,
       3,     1,     1,     1,     4,     3,     3,     3,     3,     3,
       4,     8,     3,     2,     2,     1,     3,     1,     3,     1,
       3,     5,     1,     3,     3,     3,     3,     3,     3,     1,
       3,     0,     3,     0,     6,     5,     5,     4,     5
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
      34,     0,    73,     0,     1,     2,     0,    38,    37,     0,
       0,    43,    29,    42,    20,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    41,     0,    55,     0,
      32,     0,     0,     0,     0,     0,    40,    39,     0,    31,
       0,     0,     0,     0,    18,    20,     0,     0,    53,    20,
      54,     0,     0,     0,    59,    62,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    33,     0,     3,     0,
      26,     0,     0,    24,    25,    27,     0,     0,     0,     0,
       0,     0,     0,    19,    52,     0,    49,     0,     0,    77,
      17,    16,    15,     0,    55,     0,     0,     8,    14,     4,
       9,     0,    71,    45,    46,    47,    48,    13,     0,    56,
       0,    35,     0,    21,    22,     0,    30,    50,     0,     0,
       0,     0,    23,     0,    60,    63,    76,    44,     0,     0,
       0,     0,    78,    75,    36,    28,     0,     0,     0,     0,
      57,     0,     0,     0,    12,     0,    69,     0,    74,     0,
       5,     6,     0,     0,    61,     0,     0,     0,     0,     0,
       0,     0,    72,     0,     0,    11,    58,     7,     0,    64,
      65,    66,    67,    68,    70,    51,     0,    10
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,    25,    26,   134,    84,    85,    86,    39,
      27,    32,     3,    34,    29,   151,    55,    56,   156,   157,
     141,     5
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -125
static const yytype_int16 yypact[] =
{
    -125,    10,  -125,    49,  -125,    92,    -2,  -125,  -125,   162,
     105,  -125,   -22,  -125,  -125,    -7,    33,    44,    88,   162,
     183,   193,   162,   214,   214,    64,  -125,    93,   139,   -16,
    -125,    -9,   214,    13,   252,    -6,  -125,  -125,     1,  -125,
     214,   214,   214,   214,  -125,  -125,   214,   214,  -125,  -125,
    -125,   289,   232,   247,   209,  -125,    20,   162,   162,   162,
     214,   214,    59,   214,    52,    52,   214,   214,   214,   214,
     214,   214,   214,   214,   214,   214,  -125,   256,  -125,    36,
    -125,    97,   117,  -125,  -125,  -125,   120,    63,   299,   303,
     312,   228,   267,  -125,  -125,   214,  -125,    -1,   214,  -125,
     333,   112,  -125,    51,   325,   129,    52,  -125,   325,  -125,
    -125,   275,   186,    55,    55,  -125,  -125,   325,   262,   325,
      77,  -125,    96,  -125,  -125,     1,  -125,  -125,   214,    52,
     127,   281,  -125,    52,  -125,  -125,  -125,  -125,   115,   114,
     214,   116,  -125,  -125,  -125,  -125,   316,   149,   151,   164,
    -125,   135,    52,    52,  -125,   106,  -125,   146,  -125,   214,
    -125,  -125,   177,    52,  -125,   154,   165,    52,    52,    52,
      52,    52,  -125,   214,   288,  -125,  -125,  -125,    52,  -125,
    -125,  -125,  -125,  -125,  -125,  -125,   163,  -125
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -125,  -125,  -125,    -8,   -31,    69,  -124,    80,  -125,  -125,
      -3,  -125,  -125,    -5,   166,  -125,   126,   -51,    39,  -125,
    -125,  -125
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      28,    33,    12,    31,    80,   147,   132,    83,    14,   103,
       4,    44,    74,    38,    51,    48,    50,    52,    53,    54,
      40,    81,    82,    75,   120,    76,   133,    77,    79,    57,
      58,    59,    30,   109,   110,    87,    88,    89,    90,    78,
      12,    91,    92,   179,   180,   181,   182,   183,    98,   100,
     101,   102,     6,     7,     8,    54,   104,    99,   108,    14,
      41,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      54,    42,    81,    82,     9,   138,   122,    70,    71,    98,
      57,    58,    59,    68,    69,    70,    71,    10,   136,   106,
     131,   107,   127,    54,    83,    11,    12,    13,    83,    14,
      15,    16,   150,    60,   123,    98,    17,    18,    35,    36,
      37,    19,    20,    21,   143,    43,   167,   168,   169,    22,
      61,   165,   166,   146,   124,    23,    68,    69,    70,    71,
      59,    24,   176,   144,   132,   155,    83,    83,    83,    83,
      83,   170,   171,   152,   153,    62,   154,   186,   125,    63,
      64,    65,    66,   158,   174,    67,   126,    74,   137,    68,
      69,    70,    71,   163,   164,    11,    12,    13,   155,    14,
      15,    16,   172,    72,   173,   162,    17,    18,   160,    73,
     161,    19,    20,    21,   175,   177,    11,    12,    13,    22,
      45,    15,    16,   178,   187,    23,    11,    12,    13,   148,
      49,    15,    16,    20,    21,   145,    68,    69,    70,    71,
      46,   140,   184,    20,    21,    97,    47,    11,    12,    13,
      46,    14,    15,    16,   135,     0,    47,   105,     0,    68,
      69,    70,    71,     0,    20,    21,     0,     0,    62,     0,
       0,    46,    63,    64,    65,    66,     0,    47,    68,    69,
      70,    71,    68,    69,    70,    71,     0,    94,    62,     0,
      95,    94,    63,    64,    65,    66,    72,    68,    69,    70,
      71,     0,    68,    69,    70,    71,    68,    69,    70,    71,
      96,   139,    68,    69,    70,    71,    72,    68,    69,    70,
      71,     0,     0,   121,     0,    68,    69,    70,    71,   142,
      96,    68,    69,    70,    71,    57,    58,    59,    68,    69,
      70,    71,     0,     0,   149,     0,     0,   185,    93,    68,
      69,    70,    71,    68,    69,    70,    71,   128,     0,     0,
       0,   129,    68,    69,    70,    71,    68,    69,    70,    71,
     130,     0,     0,     0,   159,    68,    69,    70,    71,    57,
      58,    59
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-125))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
       5,     9,     4,     6,     3,   129,     7,    38,     7,    60,
       0,    19,    28,    35,    22,    20,    21,    22,    23,    24,
      27,    20,    21,    39,    75,    34,    27,    32,    34,    16,
      17,    18,    34,    64,    65,    40,    41,    42,    43,    26,
       4,    46,    47,   167,   168,   169,   170,   171,    28,    57,
      58,    59,     3,     4,     5,    60,    61,    37,    63,     7,
      27,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    27,    20,    21,    25,   106,    79,    22,    23,    28,
      16,    17,    18,    20,    21,    22,    23,    38,    37,    30,
      95,    32,    29,    98,   125,     3,     4,     5,   129,     7,
       8,     9,   133,    39,     7,    28,    14,    15,     3,     4,
       5,    19,    20,    21,    37,    27,    10,    11,    12,    27,
      27,   152,   153,   128,     7,    33,    20,    21,    22,    23,
      18,    39,   163,    37,     7,   140,   167,   168,   169,   170,
     171,    35,    36,    28,    30,     6,    32,   178,    28,    10,
      11,    12,    13,    37,   159,    16,    36,    28,    29,    20,
      21,    22,    23,    28,    29,     3,     4,     5,   173,     7,
       8,     9,    26,    34,    28,    11,    14,    15,    29,    40,
      29,    19,    20,    21,     7,    31,     3,     4,     5,    27,
       7,     8,     9,    28,    31,    33,     3,     4,     5,   130,
       7,     8,     9,    20,    21,   125,    20,    21,    22,    23,
      27,    25,   173,    20,    21,     6,    33,     3,     4,     5,
      27,     7,     8,     9,    98,    -1,    33,    61,    -1,    20,
      21,    22,    23,    -1,    20,    21,    -1,    -1,     6,    -1,
      -1,    27,    10,    11,    12,    13,    -1,    33,    20,    21,
      22,    23,    20,    21,    22,    23,    -1,    29,     6,    -1,
      13,    29,    10,    11,    12,    13,    34,    20,    21,    22,
      23,    -1,    20,    21,    22,    23,    20,    21,    22,    23,
      33,     6,    20,    21,    22,    23,    34,    20,    21,    22,
      23,    -1,    -1,    37,    -1,    20,    21,    22,    23,    37,
      33,    20,    21,    22,    23,    16,    17,    18,    20,    21,
      22,    23,    -1,    -1,    33,    -1,    -1,    29,    29,    20,
      21,    22,    23,    20,    21,    22,    23,    28,    -1,    -1,
      -1,    28,    20,    21,    22,    23,    20,    21,    22,    23,
      28,    -1,    -1,    -1,    28,    20,    21,    22,    23,    16,
      17,    18
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    42,    43,    53,     0,    62,     3,     4,     5,    25,
      38,     3,     4,     5,     7,     8,     9,    14,    15,    19,
      20,    21,    27,    33,    39,    44,    45,    51,    54,    55,
      34,    51,    52,    44,    54,     3,     4,     5,    35,    50,
      27,    27,    27,    27,    44,     7,    27,    33,    54,     7,
      54,    44,    54,    54,    54,    57,    58,    16,    17,    18,
      39,    27,     6,    10,    11,    12,    13,    16,    20,    21,
      22,    23,    34,    40,    28,    39,    34,    54,    26,    34,
       3,    20,    21,    45,    47,    48,    49,    54,    54,    54,
      54,    54,    54,    29,    29,    13,    33,     6,    28,    37,
      44,    44,    44,    58,    54,    55,    30,    32,    54,    45,
      45,    54,    54,    54,    54,    54,    54,    54,    54,    54,
      58,    37,    51,     7,     7,    28,    36,    29,    28,    28,
      28,    54,     7,    27,    46,    57,    37,    29,    45,     6,
      25,    61,    37,    37,    37,    48,    54,    47,    46,    33,
      45,    56,    28,    30,    32,    54,    59,    60,    37,    28,
      29,    29,    11,    28,    29,    45,    45,    10,    11,    12,
      35,    36,    26,    28,    54,     7,    45,    31,    28,    47,
      47,    47,    47,    47,    59,    29,    45,    31
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, &yylloc, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, &yylloc)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:

/* Line 1806 of yacc.c  */
#line 127 "src/parser/parser.ypp"
    { generate_graph((yyvsp[(3) - (4)].prop)); }
    break;

  case 4:

/* Line 1806 of yacc.c  */
#line 131 "src/parser/parser.ypp"
    {
    real_op const *p = boost::get< real_op const >((yyvsp[(1) - (3)].real));
    (yyval.prop) = new ast_prop(ast_atom_bnd((yyvsp[(1) - (3)].real), (!p || p->type != UOP_ABS) ? NULL : token_zero, (yyvsp[(3) - (3)].number)));
  }
    break;

  case 5:

/* Line 1806 of yacc.c  */
#line 136 "src/parser/parser.ypp"
    { (yyval.prop) = new ast_prop(ast_atom_fix((yyvsp[(3) - (6)].real), atoi((yyvsp[(5) - (6)].number)->mantissa.c_str()))); }
    break;

  case 6:

/* Line 1806 of yacc.c  */
#line 138 "src/parser/parser.ypp"
    { (yyval.prop) = new ast_prop(ast_atom_flt((yyvsp[(3) - (6)].real), atoi((yyvsp[(5) - (6)].number)->mantissa.c_str()))); }
    break;

  case 7:

/* Line 1806 of yacc.c  */
#line 140 "src/parser/parser.ypp"
    { (yyval.prop) = new ast_prop(ast_atom_bnd((yyvsp[(1) - (7)].real), (yyvsp[(4) - (7)].number), (yyvsp[(6) - (7)].number))); }
    break;

  case 8:

/* Line 1806 of yacc.c  */
#line 141 "src/parser/parser.ypp"
    { (yyval.prop) = new ast_prop(ast_atom_bnd((yyvsp[(1) - (3)].real), NULL, NULL)); }
    break;

  case 9:

/* Line 1806 of yacc.c  */
#line 142 "src/parser/parser.ypp"
    { (yyval.prop) = new ast_prop(ast_atom_bnd((yyvsp[(1) - (3)].real), (yyvsp[(3) - (3)].number), NULL)); }
    break;

  case 10:

/* Line 1806 of yacc.c  */
#line 144 "src/parser/parser.ypp"
    { (yyval.prop) = new ast_prop(ast_atom_rel((yyvsp[(1) - (9)].real), (yyvsp[(3) - (9)].real), (yyvsp[(6) - (9)].number), (yyvsp[(8) - (9)].number))); }
    break;

  case 11:

/* Line 1806 of yacc.c  */
#line 146 "src/parser/parser.ypp"
    { (yyval.prop) = new ast_prop(ast_atom_rel((yyvsp[(2) - (7)].real), (yyvsp[(4) - (7)].real), negative_number((yyvsp[(7) - (7)].number)), (yyvsp[(7) - (7)].number))); }
    break;

  case 12:

/* Line 1806 of yacc.c  */
#line 147 "src/parser/parser.ypp"
    { (yyval.prop) = new ast_prop(ast_atom_rel((yyvsp[(1) - (5)].real), (yyvsp[(3) - (5)].real), NULL, NULL)); }
    break;

  case 13:

/* Line 1806 of yacc.c  */
#line 148 "src/parser/parser.ypp"
    { (yyval.prop) = new ast_prop(ast_atom_eql((yyvsp[(1) - (3)].real), (yyvsp[(3) - (3)].real))); }
    break;

  case 14:

/* Line 1806 of yacc.c  */
#line 150 "src/parser/parser.ypp"
    {
    ast_number const *const *r = boost::get<ast_number const *const>((yyvsp[(3) - (3)].real));
    if (r && *r == token_zero) (yyval.prop) = new ast_prop(ast_atom_nzr((yyvsp[(1) - (3)].real)));
    else (yyval.prop) = new ast_prop(new ast_prop(ast_atom_eql((yyvsp[(1) - (3)].real), (yyvsp[(3) - (3)].real))));
  }
    break;

  case 15:

/* Line 1806 of yacc.c  */
#line 155 "src/parser/parser.ypp"
    { (yyval.prop) = new ast_prop((yyvsp[(1) - (3)].prop), PROP_AND,  (yyvsp[(3) - (3)].prop)); }
    break;

  case 16:

/* Line 1806 of yacc.c  */
#line 156 "src/parser/parser.ypp"
    { (yyval.prop) = new ast_prop((yyvsp[(1) - (3)].prop), PROP_OR,   (yyvsp[(3) - (3)].prop)); }
    break;

  case 17:

/* Line 1806 of yacc.c  */
#line 157 "src/parser/parser.ypp"
    { (yyval.prop) = new ast_prop((yyvsp[(1) - (3)].prop), PROP_IMPL, (yyvsp[(3) - (3)].prop)); }
    break;

  case 18:

/* Line 1806 of yacc.c  */
#line 158 "src/parser/parser.ypp"
    { (yyval.prop) = new ast_prop((yyvsp[(2) - (2)].prop)); }
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 159 "src/parser/parser.ypp"
    { (yyval.prop) = (yyvsp[(2) - (3)].prop); }
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 162 "src/parser/parser.ypp"
    { (yyval.number) = (yyvsp[(1) - (1)].number); }
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 163 "src/parser/parser.ypp"
    { (yyval.number) = (yyvsp[(2) - (2)].number); }
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 164 "src/parser/parser.ypp"
    { (yyval.number) = negative_number((yyvsp[(2) - (2)].number)); }
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 168 "src/parser/parser.ypp"
    {
    if ((yyvsp[(1) - (1)].number)->exponent != 0 || (yyvsp[(1) - (1)].number)->mantissa.size() >= 7) failure("integer expected");
    (yyval.number) = (yyvsp[(1) - (1)].number);
  }
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 175 "src/parser/parser.ypp"
    {
    if ((yyvsp[(1) - (1)].number)->exponent != 0 || (yyvsp[(1) - (1)].number)->mantissa.size() >= 7) failure("integer expected");
    (yyval.number) = (yyvsp[(1) - (1)].number);
  }
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 181 "src/parser/parser.ypp"
    { (yyval.param) = read_integer_param((yyvsp[(1) - (1)].number)); }
    break;

  case 26:

/* Line 1806 of yacc.c  */
#line 182 "src/parser/parser.ypp"
    { (yyval.param) = reinterpret_cast< unsigned long >((yyvsp[(1) - (1)].ident)); }
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 185 "src/parser/parser.ypp"
    { (yyval.params) = new function_params(1, (yyvsp[(1) - (1)].param)); }
    break;

  case 28:

/* Line 1806 of yacc.c  */
#line 187 "src/parser/parser.ypp"
    {
    function_params *p = (yyvsp[(1) - (3)].params);
    p->push_back((yyvsp[(3) - (3)].param));
    (yyval.params) = p;
  }
    break;

  case 29:

/* Line 1806 of yacc.c  */
#line 194 "src/parser/parser.ypp"
    { (yyval.params) = NULL; }
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 195 "src/parser/parser.ypp"
    { (yyval.params) = (yyvsp[(2) - (3)].params); }
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 199 "src/parser/parser.ypp"
    {
    ast_ident *r = (yyvsp[(1) - (2)].ident);
    function_class const *f;
    if (function_params *p = (yyvsp[(2) - (2)].params)) {
      f = (*r->fun)(*p);
      delete p;
    } else f = (*r->fun)(function_params());
    if (!f) failure("invalid parameters for '" << r->name << "'");
    (yyval.function) = f;
  }
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 213 "src/parser/parser.ypp"
    {
    function_class const *f = (yyvsp[(1) - (2)].function);
    if (f->type != UOP_ID) failure("rounding operator expected, got '" << f->pretty_name() << "'");
    rounding_mode = f;
  }
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 221 "src/parser/parser.ypp"
    {
    ast_ident *v = (yyvsp[(2) - (5)].ident);
    ast_real const *r = (yyvsp[(4) - (5)].real);
    if (v->type != ID_NONE) failure("redefinition of identifier '" << (yyvsp[(2) - (5)].ident)->name << "'");
    v->type = ID_VAR;
    v->var = r;
    if (r->name) warning("renaming identifier '" << r->name->name << "' as '" << v->name << "'");
    r->name = v;
    rounding_mode = NULL;
  }
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 232 "src/parser/parser.ypp"
    {
    ast_ident *v = (yyvsp[(3) - (6)].ident);
    v->type = ID_FUN;
    v->fun = new default_function_generator((yyvsp[(5) - (6)].function));
  }
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 237 "src/parser/parser.ypp"
    { failure("redefinition of identifier '" << (yyvsp[(2) - (2)].ident)->name << "'"); }
    break;

  case 38:

/* Line 1806 of yacc.c  */
#line 238 "src/parser/parser.ypp"
    { failure("redefinition of identifier '" << (yyvsp[(2) - (2)].ident)->name << "'"); }
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 239 "src/parser/parser.ypp"
    { failure("redefinition of identifier '" << (yyvsp[(3) - (3)].ident)->name << "'"); }
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 240 "src/parser/parser.ypp"
    { failure("redefinition of identifier '" << (yyvsp[(3) - (3)].ident)->name << "'"); }
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 243 "src/parser/parser.ypp"
    { (yyval.real) = normalize(ast_real((yyvsp[(1) - (1)].number))); }
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 244 "src/parser/parser.ypp"
    { (yyval.real) = (yyvsp[(1) - (1)].ident)->var; }
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 246 "src/parser/parser.ypp"
    {
    ast_ident *v = (yyvsp[(1) - (1)].ident);
    v->type = ID_VAR;
    ast_real *r = normalize(ast_real(v));
    free_variables.insert(r);
    v->var = r;
    (yyval.real) = r;
  }
    break;

  case 44:

/* Line 1806 of yacc.c  */
#line 255 "src/parser/parser.ypp"
    {
    function_class const *f = (yyvsp[(1) - (4)].function);
    ast_real_vect *ops = (yyvsp[(3) - (4)].reals);
    if ((f->type == UOP_ID && ops->size() != 1) ||
        (f->type != UOP_ID && f->type != COP_FMA && ops->size() != 2) ||
        (f->type == COP_FMA && ops->size() != 3))
      failure("incorrect number of arguments for '" << f->pretty_name() << "'");
    (yyval.real) = normalize(ast_real(real_op(f, *ops)));
    delete ops;
  }
    break;

  case 45:

/* Line 1806 of yacc.c  */
#line 265 "src/parser/parser.ypp"
    { (yyval.real) = rnd_normalize(ast_real(real_op((yyvsp[(1) - (3)].real), BOP_ADD, (yyvsp[(3) - (3)].real)))); }
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 266 "src/parser/parser.ypp"
    { (yyval.real) = rnd_normalize(ast_real(real_op((yyvsp[(1) - (3)].real), BOP_SUB, (yyvsp[(3) - (3)].real)))); }
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 267 "src/parser/parser.ypp"
    { (yyval.real) = rnd_normalize(ast_real(real_op((yyvsp[(1) - (3)].real), BOP_MUL, (yyvsp[(3) - (3)].real)))); }
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 268 "src/parser/parser.ypp"
    { (yyval.real) = rnd_normalize(ast_real(real_op((yyvsp[(1) - (3)].real), BOP_DIV, (yyvsp[(3) - (3)].real)))); }
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 269 "src/parser/parser.ypp"
    { (yyval.real) = normalize(ast_real(real_op(UOP_ABS, (yyvsp[(2) - (3)].real)))); }
    break;

  case 50:

/* Line 1806 of yacc.c  */
#line 270 "src/parser/parser.ypp"
    { (yyval.real) = rnd_normalize(ast_real(real_op(UOP_SQRT, (yyvsp[(3) - (4)].real)))); }
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 272 "src/parser/parser.ypp"
    {
    if (!parameter_rfma)
      (yyval.real) = rnd_normalize(ast_real(real_op(normalize(ast_real(real_op((yyvsp[(3) - (8)].real), BOP_MUL, (yyvsp[(5) - (8)].real)))), BOP_ADD, (yyvsp[(7) - (8)].real))));
    else
      (yyval.real) = rnd_normalize(ast_real(real_op((yyvsp[(7) - (8)].real), BOP_ADD, normalize(ast_real(real_op((yyvsp[(3) - (8)].real), BOP_MUL, (yyvsp[(5) - (8)].real)))))));
  }
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 278 "src/parser/parser.ypp"
    { (yyval.real) = (yyvsp[(2) - (3)].real); }
    break;

  case 53:

/* Line 1806 of yacc.c  */
#line 279 "src/parser/parser.ypp"
    { (yyval.real) = (yyvsp[(2) - (2)].real); }
    break;

  case 54:

/* Line 1806 of yacc.c  */
#line 280 "src/parser/parser.ypp"
    { (yyval.real) = normalize(ast_real(real_op(UOP_NEG, (yyvsp[(2) - (2)].real)))); }
    break;

  case 55:

/* Line 1806 of yacc.c  */
#line 283 "src/parser/parser.ypp"
    { (yyval.reals) = new ast_real_vect(1, (yyvsp[(1) - (1)].real)); }
    break;

  case 56:

/* Line 1806 of yacc.c  */
#line 285 "src/parser/parser.ypp"
    {
    (yyvsp[(1) - (3)].reals)->push_back((yyvsp[(3) - (3)].real));
    (yyval.reals) = (yyvsp[(1) - (3)].reals);
  }
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 291 "src/parser/parser.ypp"
    { (yyval.param) = fill_splitter(0, (yyvsp[(1) - (1)].number)); }
    break;

  case 58:

/* Line 1806 of yacc.c  */
#line 292 "src/parser/parser.ypp"
    { (yyval.param) = fill_splitter((yyvsp[(1) - (3)].param), (yyvsp[(3) - (3)].number)); }
    break;

  case 59:

/* Line 1806 of yacc.c  */
#line 295 "src/parser/parser.ypp"
    { dichotomy_var v = { (yyvsp[(1) - (1)].real), 0 }; (yyval.dvar) = v; }
    break;

  case 60:

/* Line 1806 of yacc.c  */
#line 296 "src/parser/parser.ypp"
    { dichotomy_var v = { (yyvsp[(1) - (3)].real), read_integer_param((yyvsp[(3) - (3)].number)) }; (yyval.dvar) = v; }
    break;

  case 61:

/* Line 1806 of yacc.c  */
#line 297 "src/parser/parser.ypp"
    { dichotomy_var v = { (yyvsp[(1) - (5)].real), (yyvsp[(4) - (5)].param) }; (yyval.dvar) = v; }
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 300 "src/parser/parser.ypp"
    { (yyval.dvars) = new dvar_vect(1, (yyvsp[(1) - (1)].dvar)); }
    break;

  case 63:

/* Line 1806 of yacc.c  */
#line 302 "src/parser/parser.ypp"
    {
    (yyvsp[(1) - (3)].dvars)->push_back((yyvsp[(3) - (3)].dvar));
    (yyval.dvars) = (yyvsp[(1) - (3)].dvars);
  }
    break;

  case 64:

/* Line 1806 of yacc.c  */
#line 308 "src/parser/parser.ypp"
    { (yyval.precond) = new hint_cond(COND_NE, (yyvsp[(1) - (3)].real), (yyvsp[(3) - (3)].number)); }
    break;

  case 65:

/* Line 1806 of yacc.c  */
#line 309 "src/parser/parser.ypp"
    { (yyval.precond) = new hint_cond(COND_LE, (yyvsp[(1) - (3)].real), (yyvsp[(3) - (3)].number)); }
    break;

  case 66:

/* Line 1806 of yacc.c  */
#line 310 "src/parser/parser.ypp"
    { (yyval.precond) = new hint_cond(COND_GE, (yyvsp[(1) - (3)].real), (yyvsp[(3) - (3)].number)); }
    break;

  case 67:

/* Line 1806 of yacc.c  */
#line 311 "src/parser/parser.ypp"
    { (yyval.precond) = new hint_cond(COND_LT, (yyvsp[(1) - (3)].real), (yyvsp[(3) - (3)].number)); }
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 312 "src/parser/parser.ypp"
    { (yyval.precond) = new hint_cond(COND_GT, (yyvsp[(1) - (3)].real), (yyvsp[(3) - (3)].number)); }
    break;

  case 69:

/* Line 1806 of yacc.c  */
#line 315 "src/parser/parser.ypp"
    { (yyval.preconds) = new hint_cond_vect(1, (yyvsp[(1) - (1)].precond)); }
    break;

  case 70:

/* Line 1806 of yacc.c  */
#line 317 "src/parser/parser.ypp"
    {
    (yyvsp[(1) - (3)].preconds)->push_back((yyvsp[(3) - (3)].precond));
    (yyval.preconds) = (yyvsp[(1) - (3)].preconds);
  }
    break;

  case 71:

/* Line 1806 of yacc.c  */
#line 323 "src/parser/parser.ypp"
    { (yyval.preconds) = NULL; }
    break;

  case 72:

/* Line 1806 of yacc.c  */
#line 324 "src/parser/parser.ypp"
    { (yyval.preconds) = (yyvsp[(2) - (3)].preconds); }
    break;

  case 74:

/* Line 1806 of yacc.c  */
#line 328 "src/parser/parser.ypp"
    {
    ast_real const *r1 = (yyvsp[(2) - (6)].real), *r2 = (yyvsp[(4) - (6)].real);
    hint_cond_vect *hc = (yyvsp[(5) - (6)].preconds);
    test_ringularity(r1, r2, !hc);
    std::string info;
    int t = test_rewriting(r1, r2, info);
    if (t == 1) {
      warning("no need for the rewriting");
      std::cerr << "  if one of the following relations is present\n" << info;
    } else if (t == 2) {
      warning("no need for the rewriting");
      if (!info.empty())
        std::cerr << "  if all the following properties can be proved\n" << info;
    }
    check_approx(r1);
    register_user_rewrite(r1, r2, hc);
    register_approx(r1, r2);
    delete hc;
  }
    break;

  case 75:

/* Line 1806 of yacc.c  */
#line 348 "src/parser/parser.ypp"
    {
    dichotomy_hint h;
    h.src = *(yyvsp[(4) - (5)].dvars); delete (yyvsp[(4) - (5)].dvars);
    ast_prop *p = NULL;
    for (ast_real_vect::const_iterator i = (yyvsp[(2) - (5)].reals)->begin(), i_end = (yyvsp[(2) - (5)].reals)->end();
         i != i_end; ++i)
    {
      ast_prop *q = new ast_prop(ast_atom_bnd(*i, NULL, NULL));
      if (!p) p = q;
      else p = new ast_prop(p, PROP_AND, q);
    }
    delete (yyvsp[(2) - (5)].reals);
    parse_property_tree(h.dst, p);
    dichotomies.push_back(h);
  }
    break;

  case 76:

/* Line 1806 of yacc.c  */
#line 364 "src/parser/parser.ypp"
    {
    dichotomy_hint h;
    h.src = *(yyvsp[(4) - (5)].dvars); delete (yyvsp[(4) - (5)].dvars);
    parse_property_tree(h.dst, (yyvsp[(2) - (5)].prop));
    dichotomies.push_back(h);
  }
    break;

  case 77:

/* Line 1806 of yacc.c  */
#line 371 "src/parser/parser.ypp"
    {
    dichotomy_hint h;
    h.src = *(yyvsp[(3) - (4)].dvars); delete (yyvsp[(3) - (4)].dvars);
    dichotomies.push_back(h);
  }
    break;

  case 78:

/* Line 1806 of yacc.c  */
#line 377 "src/parser/parser.ypp"
    {
    if (!register_approx((yyvsp[(2) - (5)].real), (yyvsp[(4) - (5)].real)))
      warning("relation already known");
  }
    break;



/* Line 1806 of yacc.c  */
#line 2333 "src/parser/parser.cpp"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



